// $Id$
//
// Copyright (C) 2008 

/** \file
    \brief UDPForwarder public header */

#ifndef HH_UDPForwarder_
#define HH_UDPForwarder_ 1

// Custom includes
#include <senf/Socket/Protocols/INet/UDPSocketHandle.hh>
#include <senf/Socket/Protocols/INet/ConnectedUDPSocketHandle.hh>
#include <senf/Scheduler/Scheduler.hh>
#include <senf/Utils/membind.hh>
#include <senf/Utils/Exception.hh>
#include <senf/Utils/Logger.hh>

//#include "UDPForwarder.mpp"
///////////////////////////////hh.p////////////////////////////////////////

namespace udpforward {

    class UDPForwarder
    {
    public:
        SENF_LOG_CLASS_AREA();

	UDPForwarder(senf::INet4SocketAddress const & addr,
		     senf::INet4SocketAddress const & target);
	
	struct ForwarderException : public senf::Exception
	{ ForwarderException(std::string const & msg) : senf::Exception(msg) {} };
	
    private:
	void readEvent(int event);
	
	senf::UDPv4ClientSocketHandle socket_;
        senf::INet4SocketAddress target_;
	senf::INet4SocketAddress peer_;
	senf::scheduler::FdEvent event_;
    };

}

///////////////////////////////hh.e////////////////////////////////////////
//#include "UDPForwarder.cci"
//#include "UDPForwarder.ct"
//#include "UDPForwarder.cti"
#endif


// Local Variables:
// mode: c++
// fill-column: 100
// indent-tabs-mode: nil
// compile-command: "scons"
// comment-column: 40
// End:
